
RGraph=window.RGraph||{isrgraph:true,isRGraph:true,rgraph:true};RGraph.Bipolar=function(conf)
{var id=conf.id,canvas=document.getElementById(id),left=conf.left,right=conf.right;this.id=id;this.canvas=canvas;this.context=this.canvas.getContext('2d');this.canvas.__object__=this;this.type='bipolar';this.coords=[];this.coords2=[];this.coordsLeft=[];this.coordsRight=[];this.coords2Left=[];this.coords2Right=[];this.max=0;this.isRGraph=true;this.isrgraph=true;this.rgraph=true;this.uid=RGraph.createUID();this.canvas.uid=this.canvas.uid?this.canvas.uid:RGraph.createUID();this.coordsText=[];this.original_colors=[];this.firstDraw=true;var data=[left,right];for(var i=0;i<2;++i){data[i].forEach(function(v,k,arr)
{if(RGraph.isNull(v)){}else if(typeof v==='object'){v.forEach(function(v2,k2,arr2)
{arr[k][k2]=parseFloat(v2);});}else{arr[k]=parseFloat(v);}
arr[k]=RGraph.stringsToNumbers(arr[k]);});}
this.left=left;this.right=right;this.data=[left,right];this.data2=[];for(var i=0;i<left.length;++i)this.data2.push(left[i]);for(var i=0;i<right.length;++i)this.data2.push(right[i]);this.properties={backgroundGrid:true,backgroundGridColor:'#ddd',backgroundGridVlines:true,backgroundGridHlines:true,backgroundGridLinewidth:1,backgroundGridVlinesCount:null,backgroundGridHlinesCount:null,xaxis:true,xaxisTickmarksCount:5,xaxisTickmarksInterval:null,xaxisScaleUnitsPre:'',xaxisScaleUnitsPost:'',xaxisScaleMax:null,xaxisScaleMin:0,xaxisScaleZerostart:true,xaxisScaleDecimals:null,xaxisScalePoint:'.',xaxisScaleThousand:',',xaxisLabels:true,xaxisLabelsFont:null,xaxisLabelsSize:null,xaxisLabelsColor:null,xaxisLabelsBold:null,xaxisLabelsItalic:null,xaxisLabelsCount:5,yaxis:true,yaxisTickmarksCount:null,yaxisLabels:[],yaxisLabelsFont:null,yaxisLabelsSize:null,yaxisLabelsColor:null,yaxisLabelsBold:null,yaxisLabelsItalic:null,labelsAbove:false,labelsAboveFont:null,labelsAboveSize:null,labelsAboveBold:null,labelsAboveItalic:null,labelsAboveColor:null,labelsAboveUnitsPre:'',labelsAboveUnitsPost:'',labelsAboveDecimals:0,labelsAboveFormatter:null,textBold:false,textItalic:false,textSize:12,textColor:'black',textFont:'Arial, Verdana, sans-serif',textAccessible:true,textAccessibleOverflow:'visible',textAccessiblePointerevents:false,titleLeft:null,titleLeftFont:null,titleLeftSize:null,titleLeftBold:null,titleLeftItalic:null,titleLeftColor:null,titleRight:null,titleRightFont:null,titleRightSize:null,titleRightBold:null,titleRightItalic:null,titleRightColor:null,marginCenter:0,marginCenterAuto:true,marginLeft:35,marginRight:35,marginTop:35,marginBottom:35,marginInner:5,marginInnerGrouped:3,title:null,titleFont:null,titleSize:null,titleBold:null,titleItalic:null,titleColor:null,titleBackground:null,titleHpos:null,titleVpos:null,titleX:null,titleY:null,titleHalign:null,titleValign:null,colorsStroke:'rgba(0,0,0,0)',colors:['#afa','#faa','#aaf','#aff','#ffa','#faf','cyan','brown','gray','black','pink','#afa','#faa','#aaf','#aff','#ffa','#faf','cyan','brown','gray','black','pink'],colorsSequential:false,contextmenu:null,tooltips:null,tooltipsEffect:'fade',tooltipsCssClass:'RGraph_tooltip',tooltipsCss:null,tooltipsHighlight:true,tooltipsEvent:'onclick',tooltipsFormattedThousand:',',tooltipsFormattedPoint:'.',tooltipsFormattedDecimals:0,tooltipsFormattedUnitsPre:'',tooltipsFormattedUnitsPost:'',tooltipsFormattedKeyColors:null,tooltipsFormattedKeyColorsShape:'square',tooltipsFormattedKeyLabels:[],highlightStroke:'rgba(0,0,0,0)',highlightFill:'rgba(255,255,255,0.7)',shadow:false,shadowColor:'#ccc',shadowOffsetx:3,shadowOffsety:3,shadowOlur:3,annotatable:false,annotatableColor:'black',axes:true,axesColor:'black',axesLinewidth:1,resizable:false,resizableHandleBackground:null,linewidth:1,variantThreedOffsetx:10,variantThreedOffsety:5,variantThreedAngle:0.1,grouping:'grouped',clearto:'rgba(0,0,0,0)'}
this.properties.yaxisTickmarksCount=this.left.length;var linear_data=RGraph.arrayLinearize(this.left,this.right);for(var i=0;i<linear_data.length;++i){this['$'+i]={};}
if(!this.canvas.__rgraph_aa_translated__){this.context.translate(0.5,0.5);this.canvas.__rgraph_aa_translated__=true;}
var prop=this.properties;this.path=RGraph.pathObjectFunction;if(RGraph.Effects&&typeof RGraph.Effects.decorate==='function'){RGraph.Effects.decorate(this);}
this.responsive=RGraph.responsive;this.set=function(name)
{var value=typeof arguments[1]==='undefined'?null:arguments[1];if(arguments.length===1&&typeof arguments[0]==='object'){for(i in arguments[0]){if(typeof i==='string'){this.set(i,arguments[0][i]);}}
return this;}
prop[name]=value;return this;};this.get=function(name)
{return this.properties[name];};this.draw=function()
{RGraph.fireCustomEvent(this,'onbeforedraw');if(!this.colorsParsed){this.parseColors();this.colorsParsed=true;}
this.marginLeft=prop.marginLeft;this.marginRight=prop.marginRight;this.marginTop=prop.marginTop;this.marginBottom=prop.marginBottom;this.marginCenter=prop.marginCenter;this.marginCenterAuto=prop.marginCenterAuto;if(prop.marginCenterAuto&&!prop.marginCenter){prop.marginCenter=this.getMarginCenter();}
this.marginCenter=prop.marginCenter;this.left=this.data[0];this.right=this.data[1];this.coords=[];this.coords2=[];this.coordsLeft=[];this.coordsRight=[];this.coords2Left=[];this.coords2Right=[];this.coordsText=[];if(prop.variant==='3d'){if(prop.textAccessible){}else{this.context.setTransform(1,prop.variantThreedAngle,0,1,0.5,0.5);}}
this.axisWidth=(this.canvas.width-prop.marginCenter-this.marginLeft-this.marginRight)/2;this.axisHeight=this.canvas.height-this.marginTop-this.marginBottom;this.sequentialFullIndex=0;this.getMax();this.drawBackgroundGrid();this.draw3DAxes();this.drawAxes();this.drawTicks();this.drawLeftBars();this.drawRightBars();this.drawLeftBars({shadow:false});this.drawRightBars({shadow:false});this.drawAxes();this.drawLabels();this.drawTitles();if(prop.contextmenu){RGraph.showContext(this);}
if(prop.resizable){RGraph.allowResizing(this);}
RGraph.installEventListeners(this);if(this.firstDraw){this.firstDraw=false;RGraph.fireCustomEvent(this,'onfirstdraw');this.firstDrawFunc();}
RGraph.fireCustomEvent(this,'ondraw');return this;};this.exec=function(func)
{func(this);return this;};this.draw3DAxes=function()
{if(prop.variant==='3d'){var offsetx=prop.variantThreedOffsetx,offsety=prop.variantThreedOffsety;this.context.lineWidth=prop.axesLinewidth+0.001;this.context.beginPath();this.context.strokeStyle=prop.axesColor;this.path('b m % % l % % l % % l % % s #aaa f #ddd',this.marginLeft,this.canvas.height-this.marginBottom,this.marginLeft+offsetx,this.canvas.height-this.marginBottom-offsety,this.marginLeft+offsetx+this.axisWidth,this.canvas.height-this.marginBottom-offsety,this.marginLeft+this.axisWidth,this.canvas.height-this.marginBottom);this.draw3DLeftVerticalAxis();this.path('b m % % l % % l % % l % % s #aaa f #ddd',this.marginLeft+this.marginCenter+this.axisWidth,this.canvas.height-this.marginBottom,this.marginLeft+this.marginCenter+this.axisWidth+offsetx,this.canvas.height-this.marginBottom-offsety,this.marginLeft+this.marginCenter+this.axisWidth+this.axisWidth+offsetx,this.canvas.height-this.marginBottom-offsety,this.marginLeft+this.marginCenter+this.axisWidth+this.axisWidth,this.canvas.height-this.marginBottom);this.path('b m % % l % % l % % l % % s #aaa f #ddd',this.marginLeft+this.marginCenter+this.axisWidth,this.canvas.height-this.marginBottom,this.marginLeft+this.marginCenter+this.axisWidth,this.canvas.height-this.marginBottom-this.axisHeight,this.marginLeft+this.marginCenter+this.axisWidth+offsetx,this.canvas.height-this.marginBottom-this.axisHeight-offsety,this.marginLeft+this.marginCenter+this.axisWidth+offsetx,this.canvas.height-this.marginBottom-offsety);}}
this.draw3DLeftVerticalAxis=function()
{if(prop.variant==='3d'){var offsetx=prop.variantThreedOffsetx,offsety=prop.variantThreedOffsety;this.path('b m % % l % % l % % l % % s #aaa f #ddd',this.marginLeft+this.axisWidth,this.marginTop,this.marginLeft+this.axisWidth+offsetx,this.marginTop-offsety,this.marginLeft+this.axisWidth+offsetx,this.canvas.height-this.marginBottom-offsety,this.marginLeft+this.axisWidth,this.canvas.height-this.marginBottom);}};this.drawAxes=function()
{this.context.lineWidth=prop.axesLinewidth+0.001;this.context.beginPath();this.context.strokeStyle=prop.axesColor;this.axisWidth=(this.canvas.width-prop.marginCenter-this.marginLeft-this.marginRight)/2;this.axisHeight=this.canvas.height-this.marginTop-this.marginBottom;if(!prop.axes){return;}
if(prop.xaxis){this.context.moveTo(this.marginLeft,this.canvas.height-this.marginBottom);this.context.lineTo(this.marginLeft+this.axisWidth,this.canvas.height-this.marginBottom);}
if(prop.yaxis){this.context.moveTo(this.marginLeft+this.axisWidth,this.canvas.height-this.marginBottom);this.context.lineTo(this.marginLeft+this.axisWidth,this.marginTop);}
this.context.stroke();this.context.beginPath();var x=this.marginLeft+this.axisWidth+prop.marginCenter;if(prop.yaxis){this.context.moveTo(x,this.marginTop);this.context.lineTo(x,this.canvas.height-this.marginBottom);}
if(prop.xaxis){this.context.moveTo(x,this.canvas.height-this.marginBottom);this.context.lineTo(this.canvas.width-this.marginRight,this.canvas.height-this.marginBottom);}
this.context.stroke();};this.drawTicks=function()
{this.context.lineWidth=prop.axesLinewidth+0.001;var numDataPoints=this.left.length;var barHeight=((this.canvas.height-this.marginTop-this.marginBottom)-(this.left.length*(prop.marginInner*2)))/numDataPoints;this.barHeight=barHeight;if(!prop.axes){return;}
if(prop.yaxis&&prop.yaxisTickmarksCount>0){this.context.beginPath();for(var i=0;i<prop.yaxisTickmarksCount;++i){var y=prop.marginTop+(((this.canvas.height-this.marginTop-this.marginBottom)/prop.yaxisTickmarksCount)*i);this.context.moveTo(this.marginLeft+this.axisWidth,y);this.context.lineTo(this.marginLeft+this.axisWidth+3,y);}
this.context.stroke();this.context.beginPath();for(var i=0;i<prop.yaxisTickmarksCount;++i){var y=prop.marginTop+(((this.canvas.height-this.marginTop-this.marginBottom)/prop.yaxisTickmarksCount)*i);this.context.moveTo(this.marginLeft+this.axisWidth+prop.marginCenter,y);this.context.lineTo(this.marginLeft+this.axisWidth+prop.marginCenter-3,y);}
this.context.stroke();if(!prop.xaxis){this.path('b m % % l % % s %',this.marginLeft+this.axisWidth,this.canvas.height-this.marginBottom,this.marginLeft+this.axisWidth+4,(this.canvas.height-this.marginBottom),this.context.strokeStyle);this.path('b m % % l % % s %',this.marginLeft+this.axisWidth+prop.marginCenter,this.canvas.height-this.marginBottom,this.marginLeft+this.axisWidth+prop.marginCenter-4,this.canvas.height-this.marginBottom,this.context.strokeStyle);}}
if(prop.xaxis&&prop.xaxisTickmarksCount>0){var xInterval=this.axisWidth/prop.xaxisTickmarksCount;if(typeof prop.xaxisTickmarksInterval=='number'){xInterval=prop.xaxisTickmarksInterval;}
for(i=this.marginLeft;i<(this.marginLeft+this.axisWidth);i+=xInterval){this.context.beginPath();this.context.moveTo(i,this.canvas.height-this.marginBottom);this.context.lineTo(i,(this.canvas.height-this.marginBottom)+4);this.context.closePath();this.context.stroke();}
var stoppingPoint=this.canvas.width-this.marginRight+1;for(i=(this.marginLeft+this.axisWidth+prop.marginCenter+xInterval);i<=stoppingPoint;i+=xInterval){this.context.beginPath();this.context.moveTo(i,this.canvas.height-this.marginBottom);this.context.lineTo(i,(this.canvas.height-this.marginBottom)+4);this.context.closePath();this.context.stroke();}
if(!prop.yaxis){this.path('b m % % l % % s %',this.marginLeft+this.axisWidth,this.canvas.height-this.marginBottom,this.marginLeft+this.axisWidth,(this.canvas.height-this.marginBottom)+4,this.context.strokeStyle);this.path('b m % % l % % s %',this.marginLeft+this.axisWidth+prop.marginCenter,this.canvas.height-this.marginBottom,this.marginLeft+this.axisWidth+prop.marginCenter,(this.canvas.height-this.marginBottom)+4,this.context.strokeStyle);}}};this.getMax=function()
{var dec=prop.xaxisScaleDecimals;if(prop.xaxisScaleMax){var max=prop.xaxisScaleMax;var min=prop.xaxisScaleMin;this.scale2=RGraph.getScale({object:this,options:{'scale.max':max,'scale.min':min,'scale.strict':true,'scale.thousand':prop.xaxisScaleThousand,'scale.point':prop.xaxisScalePoint,'scale.decimals':prop.xaxisScaleDecimals,'scale.labels.count':prop.xaxisLabelsCount,'scale.round':prop.xaxisScaleRound,'scale.units.pre':prop.xaxisScaleUnitsPre,'scale.units.post':prop.xaxisScaleUnitsPost}});this.max=this.scale2.max;this.min=this.scale2.min;}else{var max=1;for(var i=0;i<this.left.length;++i){if(typeof this.left[i]==='number'){max=Math.max(max,this.left[i]);}else if(RGraph.isNull(this.left[i])){}else{max=Math.max(max,prop.grouping==='stacked'?RGraph.arraySum(this.left[i]):RGraph.arrayMax(this.left[i]));}}
for(var i=0;i<this.right.length;++i){if(typeof this.right[i]==='number'){max=Math.max(max,this.right[i]);}else if(RGraph.isNull(this.right[i])){}else{max=Math.max(max,prop.grouping==='stacked'?RGraph.arraySum(this.right[i]):RGraph.arrayMax(this.right[i]));}}
this.scale2=RGraph.getScale({object:this,options:{'scale.max':max,'scale.min':prop.xaxisScaleMin,'scale.thousand':prop.xaxisScaleThousand,'scale.point':prop.xaxisScalePoint,'scale.decimals':prop.xaxisScaleDecimals,'scale.labels.count':prop.xaxisLabelsCount,'scale.round':prop.xaxisScaleRound,'scale.units.pre':prop.xaxisScaleUnitsPre,'scale.units.post':prop.xaxisScaleUnitsPost}});this.max=this.scale2.max;this.min=this.scale2.min;}};this.drawLeftBars=function()
{var opt={};if(typeof arguments[0]==='object'){opt.shadow=arguments[0].shadow;}else{opt.shadow=true;}
var offsetx=prop.variantThreedOffsetx,offsety=prop.variantThreedOffsety;this.context.strokeStyle=prop.colorsStroke;this.context.lineWidth=prop.linewidth;for(var i=0,sequentialColorIndex=0;i<this.left.length;++i){if(prop.shadow&&prop.variant!=='3d'&&opt.shadow){RGraph.setShadow({object:this,prefix:'shadow'});}
if(typeof this.left[i]==='number'){if(prop.colorsSequential){this.context.fillStyle=prop.colors[sequentialColorIndex];}else{this.context.fillStyle=prop.colors[0];if(prop.colors.length===2){this.context.fillStyle=prop.colors[0];}}
var width=(((this.left[i]-this.min)/(this.max-this.min))*this.axisWidth);var coords=[this.marginLeft+this.axisWidth-width,this.marginTop+(i*(this.axisHeight/this.left.length))+prop.marginInner,width,this.barHeight];if(this.left[i]!==null){this.context.strokeRect(coords[0],coords[1],coords[2],coords[3]);this.context.fillRect(coords[0],coords[1],coords[2],coords[3]);}
if(prop.variant==='3d'&&this.left[i]!==null){if(prop.shadow&&opt.shadow){this.context.shadowColor=prop.shadowColor;this.context.shadowBlur=prop.shadowBlur;this.context.shadowOffsetX=prop.shadowOffsetx;this.context.shadowOffsetY=prop.shadowOffsety;this.path('b m % % l % % l % % l % % f black sc rgba(0,0,0,0) sx 0 sy 0 sb 0',coords[0]+offsetx,coords[1]-offsety,coords[0]+offsetx+coords[2],coords[1]-offsety,coords[0]+offsetx+coords[2],coords[1]-offsety+coords[3],coords[0]+offsetx,coords[1]-offsety+coords[3]);}
if(prop.colorsSequential){this.context.fillStyle=prop.colors[i];}else{this.context.fillStyle=prop.colors[0];}
this.path('b m % % l % % l % % l % % f',coords[0],coords[1],coords[0]+offsetx,coords[1]-offsety,coords[0]+offsetx+coords[2],coords[1]-offsety,coords[0]+coords[2],coords[1]);this.path('b m % % l % % l % % l % % f rgba(255,255,255,0.4)',coords[0],coords[1],coords[0]+offsetx,coords[1]-offsety,coords[0]+offsetx+coords[2],coords[1]-offsety,coords[0]+coords[2],coords[1]);}
if(!opt.shadow){this.coords.push([coords[0],coords[1],coords[2],coords[3]]);this.coordsLeft.push([coords[0],coords[1],coords[2],coords[3]]);}
sequentialColorIndex++;}else if(typeof this.left[i]==='object'&&prop.grouping==='stacked'){for(var j=0,accumulatedWidth=0;j<this.left[i].length;++j){if(prop.colorsSequential){this.context.fillStyle=prop.colors[sequentialColorIndex];}else{this.context.fillStyle=prop.colors[j];}
var value=this.left[i][j],min=this.min,max=this.max,margin=prop.marginInner,width=(((value-min)/(max-min))*this.axisWidth),sectionHeight=(this.axisHeight/this.left.length),height=(sectionHeight-(2*margin)),x=this.marginLeft+this.axisWidth-width-accumulatedWidth,y=this.marginTop+margin+(i*sectionHeight);accumulatedWidth+=width;if(this.left[i]!==null){this.context.strokeRect(x,y,width,height);this.context.fillRect(x,y,width,height);}
if(prop.variant==='3d'&&this.left[i]!==null){if(prop.shadow&&opt.shadow){this.context.shadowColor=prop.shadowColor;this.context.shadowBlur=prop.shadowBlur;this.context.shadowOffsetX=prop.shadowOffsetx;this.context.shadowOffsetY=prop.shadowOffsety;this.path('b m % % l % % l % % l % % f black sc rgba(0,0,0,0) sx 0 sy 0 sb 0',x+offsetx,y-offsety,x+offsetx+width,y-offsety,x+offsetx+width,y-offsety+height,x+offsetx,y-offsety+height);}
if(prop.colorsSequential){this.context.fillStyle=prop.colors[sequentialColorIndex];}else{this.context.fillStyle=prop.colors[j];}
this.path('b m % % l % % l % % l % % f',x,y,x+offsetx,y-offsety,x+offsetx+width,y-offsety,x+width,y);this.path('b m % % l % % l % % l % % f rgba(255,255,255,0.4)',x,y,x+offsetx,y-offsety,x+offsetx+width,y-offsety,x+width,y);}
if(!opt.shadow){this.coords.push([x,y,width,height]);this.coordsLeft.push([x,y,width,height]);if(!RGraph.isArray(this.coords2[i])){this.coords2[i]=[];}
this.coords2[i].push([x,y,width,height]);if(!RGraph.isArray(this.coords2Left[i])){this.coords2Left[i]=[];}
this.coords2Left[i].push([x,y,width,height]);}
sequentialColorIndex++;}}else if(typeof this.left[i]==='object'&&!RGraph.isNull(this.left[i])){for(var j=0;j<this.left[i].length;++j){if(prop.colorsSequential){this.context.fillStyle=prop.colors[sequentialColorIndex];}else{this.context.fillStyle=prop.colors[j];}
var value=this.left[i][j],min=this.min,max=this.max,margin=prop.marginInner,marginGrouped=prop.marginInnerGrouped,width=(((value-min)/(max-min))*this.axisWidth),sectionHeight=(this.axisHeight/this.left.length),height=(sectionHeight-(2*margin)-((this.left[i].length-1)*marginGrouped))/this.left[i].length,x=this.marginLeft+this.axisWidth-width,y=this.marginTop+margin+(i*sectionHeight)+(height*j)+(j*marginGrouped);if(this.left[i]!==null){this.context.strokeRect(x,y,width,height);this.context.fillRect(x,y,width,height);}
if(prop.variant==='3d'&&this.left[i]!==null){if(prop.shadow&&opt.shadow){this.context.shadowColor=prop.shadowColor;this.context.shadowBlur=prop.shadowBlur;this.context.shadowOffsetX=prop.shadowOffsetx;this.context.shadowOffsetY=prop.shadowOffsety;this.path('b m % % l % % l % % l % % f black sc rgba(0,0,0,0) sx 0 sy 0 sb 0',x+offsetx,y-offsety,x+offsetx+width,y-offsety,x+offsetx+width,y-offsety+height,x+offsetx,y-offsety+height);}
if(prop.colorsSequential){this.context.fillStyle=prop.colors[sequentialColorIndex];}else{this.context.fillStyle=prop.colors[j];}
this.path('b m % % l % % l % % l % % f',x,y,x+offsetx,y-offsety,x+offsetx+width,y-offsety,x+width,y);this.path('b m % % l % % l % % l % % f rgba(255,255,255,0.4)',x,y,x+offsetx,y-offsety,x+offsetx+width,y-offsety,x+width,y);}
if(!opt.shadow){this.coords.push([x,y,width,height]);this.coordsLeft.push([x,y,width,height]);if(!RGraph.isArray(this.coords2[i])){this.coords2[i]=[];}
this.coords2[i].push([x,y,width,height]);if(!RGraph.isArray(this.coords2Left[i])){this.coords2Left[i]=[];}
this.coords2Left[i].push([x,y,width,height]);}
sequentialColorIndex++;}}
this.draw3DLeftVerticalAxis();}
RGraph.noShadow(this);this.context.lineWidth=1;};this.drawRightBars=function()
{var opt={};if(typeof arguments[0]==='object'){opt.shadow=arguments[0].shadow;}else{opt.shadow=true;}
var offsetx=prop.variantThreedOffsetx,offsety=prop.variantThreedOffsety;this.context.strokeStyle=prop.colorsStroke;this.context.lineWidth=prop.linewidth;if(prop.shadow&&prop.variant!=='3d'&&opt.shadow){this.context.shadowColor=prop.shadowColor;this.context.shadowBlur=prop.shadowBlur;this.context.shadowOffsetX=prop.shadowOffsetx;this.context.shadowOffsetY=prop.shadowOffsety;}
for(var i=0,sequentialColorIndex=RGraph.arrayLinearize(this.left).length;i<this.right.length;++i){if(typeof this.right[i]==='number'){if(prop.colorsSequential){this.context.fillStyle=prop.colors[sequentialColorIndex];}else{this.context.fillStyle=prop.colors[0];if(prop.colors.length===2){this.context.fillStyle=prop.colors[1];}}
var width=(((this.right[i]-this.min)/(this.max-this.min))*this.axisWidth);var coords=[this.marginLeft+this.axisWidth+prop.marginCenter,prop.marginInner+(i*(this.axisHeight/this.right.length))+this.marginTop,width,this.barHeight];if(this.right[i]!==null){this.context.strokeRect(coords[0],coords[1],coords[2],coords[3]);this.context.fillRect(coords[0],coords[1],coords[2],coords[3]);}
if(prop.variant==='3d'&&this.right[i]!==null){var color=this.context.fillStyle;if(prop.shadow&&opt.shadow){this.context.shadowColor=prop.shadowColor;this.context.shadowBlur=prop.shadowBlur;this.context.shadowOffsetX=prop.shadowOffsetx;this.context.shadowOffsetY=prop.shadowOffsety;this.path('b m % % l % % l % % l % % f black sc rgba(0,0,0,0) sx 0 sy 0 sb 0',coords[0]+offsetx,coords[1]-offsety,coords[0]+offsetx+coords[2],coords[1]-offsety,coords[0]+offsetx+coords[2],coords[1]-offsety+coords[3],coords[0]+offsetx,coords[1]-offsety+coords[3]);}
this.path('b m % % l % % l % % l % % f %',coords[0],coords[1],coords[0]+offsetx,coords[1]-offsety,coords[0]+offsetx+coords[2],coords[1]-offsety,coords[0]+coords[2],coords[1],color);this.path('b m % % l % % l % % l % % f %',coords[0]+coords[2],coords[1],coords[0]+coords[2]+offsetx,coords[1]-offsety,coords[0]+coords[2]+offsetx,coords[1]-offsety+coords[3],coords[0]+coords[2],coords[1]+coords[3],color);this.path('b m % % l % % l % % l % % f rgba(255,255,255,0.6)',coords[0],coords[1],coords[0]+offsetx,coords[1]-offsety,coords[0]+offsetx+coords[2],coords[1]-offsety,coords[0]+coords[2],coords[1]);this.path('b m % % l % % l % % l % % f rgba(0,0,0,0.3)',coords[0]+coords[2],coords[1],coords[0]+coords[2]+offsetx,coords[1]-offsety,coords[0]+coords[2]+offsetx,coords[1]-offsety+coords[3],coords[0]+coords[2],coords[1]+coords[3]);}
if(!opt.shadow){this.coords.push([coords[0],coords[1],coords[2],coords[3]]);this.coordsRight.push([coords[0],coords[1],coords[2],coords[3]]);}
sequentialColorIndex++;}else if(typeof this.left==='object'&&prop.grouping==='stacked'){for(var j=0,accumulatedWidth=0;j<this.right[i].length;++j){if(prop.colorsSequential){this.context.fillStyle=prop.colors[sequentialColorIndex];}else{this.context.fillStyle=prop.colors[j];}
var value=this.right[i][j],min=this.min,max=this.max,margin=prop.marginInner,width=(((value-min)/(max-min))*this.axisWidth),sectionHeight=(this.axisHeight/this.right.length),height=(sectionHeight-(2*margin)),x=this.marginLeft+this.axisWidth+prop.marginCenter+accumulatedWidth,y=this.marginTop+margin+(i*sectionHeight);accumulatedWidth+=width;if(this.right[i]!==null){this.context.strokeRect(x,y,width,height);this.context.fillRect(x,y,width,height);}
if(prop.variant==='3d'&&this.right[i]!==null){var color=this.context.fillStyle;if(prop.shadow&&opt.shadow){RGraph.setShadow({object:this,prefix:'shadow'});this.path('b m % % l % % l % % l % % f black sc rgba(0,0,0,0) sx 0 sy 0 sb 0',x+offsetx,y-offsety,x+offsetx+width,y-offsety,x+offsetx+width,y-offsety+height,x+offsetx,y-offsety+height);}
this.path('b m % % l % % l % % l % % f %',x,y,x+offsetx,y-offsety,x+offsetx+width,y-offsety,x+width,y,color);if(j===(this.right[i].length-1)){this.path('b m % % l % % l % % l % % f %',x+width,y,x+width+offsetx,y-offsety,x+width+offsetx,y-offsety+height,x+width,y+height,color);this.path('b m % % l % % l % % l % % f rgba(0,0,0,0.3)',x+width,y,x+width+offsetx,y-offsety,x+width+offsetx,y-offsety+height,x+width,y+height);}
this.path('b m % % l % % l % % l % % f rgba(255,255,255,0.6)',x,y,x+offsetx,y-offsety,x+offsetx+width,y-offsety,x+width,y);}
if(!opt.shadow){this.coords.push([x,y,width,height]);if(!RGraph.isArray(this.coords2[sequentialColorIndex])){this.coords2[sequentialColorIndex]=[];}
this.coords2[sequentialColorIndex].push([x,y,width,height]);this.coordsRight.push([x,y,width,height]);if(!RGraph.isArray(this.coords2Right[i])){this.coords2Right[i]=[];}
this.coords2Right[i].push([x,y,width,height]);}
sequentialColorIndex++;}}else if(typeof this.right[i]==='object'){for(var j=0;j<this.right[i].length;++j){if(prop.colorsSequential){this.context.fillStyle=prop.colors[sequentialColorIndex];}else{this.context.fillStyle=prop.colors[j];}
var value=this.right[i][j],min=this.min,max=this.max,margin=prop.marginInner,marginGrouped=prop.marginInnerGrouped,width=((value-min)/(max-min))*this.axisWidth,sectionHeight=(this.axisHeight/this.right.length),height=(sectionHeight-(2*margin)-((this.right[i].length-1)*marginGrouped))/this.right[i].length,x=this.marginLeft+this.axisWidth+prop.marginCenter,y=this.marginTop+margin+(i*sectionHeight)+(height*j)+(j*marginGrouped);if(this.right[i]!==null){this.context.strokeRect(x,y,width,height);this.context.fillRect(x,y,width,height);}
if(!opt.shadow){this.coords.push([x,y,width,height]);this.coordsRight.push([x,y,width,height]);if(!RGraph.isArray(this.coords2[this.left.length+i])){this.coords2[this.left.length+i]=[];}
this.coords2[this.left.length+i].push([x,y,width,height]);if(!RGraph.isArray(this.coords2Right[i])){this.coords2Right[i]=[];}
this.coords2Right[i].push([x,y,width,height]);}
sequentialColorIndex++;if(prop.variant==='3d'&&this.right[i]!==null){var color=this.context.fillStyle;if(prop.shadow&&opt.shadow){this.context.shadowColor=prop.shadowColor;this.context.shadowBlur=prop.shadowBlur;this.context.shadowOffsetX=prop.shadowOffsetx;this.context.shadowOffsetY=prop.shadowOffsety;this.path('b m % % l % % l % % l % % f black sc rgba(0,0,0,0) sx 0 sy 0 sb 0',x+offsetx,y-offsety,x+offsetx+width,y-offsety,x+offsetx+width,y-offsety+height,x+offsetx,y-offsety+height);}
this.path('b m % % l % % l % % l % % f %',x,y,x+offsetx,y-offsety,x+offsetx+width,y-offsety,x+width,y,color);this.path('b m % % l % % l % % l % % f %',x+width,y,x+width+offsetx,y-offsety,x+width+offsetx,y-offsety+height,x+width,y+height,color);this.path('b m % % l % % l % % l % % f rgba(255,255,255,0.6)',x,y,x+offsetx,y-offsety,x+offsetx+width,y-offsety,x+width,y);this.path('b m % % l % % l % % l % % f rgba(0,0,0,0.3)',x+width,y,x+width+offsetx,y-offsety,x+width+offsetx,y-offsety+height,x+width,y+height);}}}}
RGraph.noShadow(this);this.context.lineWidth=1;};this.drawLabels=function()
{var labels=prop.yaxisLabels,barAreaHeight=this.canvas.height-this.marginTop-this.marginBottom
var textConf=RGraph.getTextConf({object:this,prefix:'yaxisLabels'});this.context.fillStyle=textConf.color;for(var i=0,len=labels.length;i<len;++i){RGraph.text({object:this,color:textConf.color,font:textConf.font,size:textConf.size,bold:textConf.bold,italic:textConf.italic,x:this.marginLeft+this.axisWidth+(prop.marginCenter/2),y:this.marginTop+((barAreaHeight/labels.length)*(i))+((barAreaHeight/labels.length)/2),text:String(labels[i]?String(labels[i]):''),halign:'center',valign:'center',marker:false,tag:'labels'});}
this.context.fillStyle=prop.textColor;if(prop.xaxisLabels){var grapharea=(this.canvas.width-prop.marginCenter-this.marginLeft-this.marginRight)/2;var textConf=RGraph.getTextConf({object:this,prefix:'xaxisLabels'});for(var i=0;i<this.scale2.labels.length;++i){RGraph.text({object:this,font:textConf.font,size:textConf.size,bold:textConf.bold,italic:textConf.italic,color:textConf.color,x:this.marginLeft+((grapharea/this.scale2.labels.length)*i),y:this.canvas.height-this.marginBottom+7,text:typeof prop.xaxisScaleFormatter==='function'?(prop.xaxisScaleFormatter)(this,this.scale2.values[this.scale2.values.length-i-1]):this.scale2.labels[this.scale2.labels.length-i-1],valign:'top',halign:'center',tag:'scale'});RGraph.text({object:this,font:textConf.font,size:textConf.size,bold:textConf.bold,italic:textConf.italic,color:textConf.color,x:this.marginLeft+grapharea+prop.marginCenter+((grapharea/this.scale2.labels.length)*(i+1)),y:this.canvas.height-this.marginBottom+7,text:this.scale2.labels[i],text:typeof prop.xaxisScaleFormatter==='function'?(prop.xaxisScaleFormatter)(this,this.scale2.values[i]):this.scale2.labels[i],valign:'top',halign:'center',tag:'scale'});}
if(prop.xaxisScaleZerostart){RGraph.text({object:this,font:textConf.font,size:textConf.size,bold:textConf.bold,italic:textConf.italic,color:textConf.color,x:this.marginLeft+this.axisWidth,y:this.canvas.height-this.marginBottom+7,text:typeof prop.xaxisScaleFormatter==='function'?(prop.xaxisScaleFormatter)(this,0):RGraph.numberFormat({object:this,number:(0).toFixed(prop.xaxisScaleDecimals),unitspre:prop.xaxisScaleUnitsPre,unitspost:prop.xaxisScaleUnitsPost}),valign:'top',halign:'center',tag:'scale'});RGraph.text({object:this,font:textConf.font,size:textConf.size,bold:textConf.bold,italic:textConf.italic,color:textConf.color,x:this.marginLeft+this.axisWidth+this.marginCenter,y:this.canvas.height-this.marginBottom+7,text:typeof prop.xaxisScaleFormatter==='function'?(prop.xaxisScaleFormatter)(this,0):RGraph.numberFormat({object:this,number:(0).toFixed(prop.xaxisScaleDecimals),unitspre:prop.xaxisScaleUnitsPre,unitspost:prop.xaxisScaleUnitsPost}),valign:'top',halign:'center',tag:'scale'});}}
if(prop.labelsAbove){this.drawLabelsAbove();}};this.drawLabelsAbove=function()
{var coordsLeft=this.coordsLeft,coordsRight=this.coordsRight;var textConf=RGraph.getTextConf({object:this,prefix:'labelsAbove'});for(var i=0,seq=0;i<coordsLeft.length;++i,++seq){if(typeof this.left[i]=='number'){var coords=this.coords[seq];RGraph.text({object:this,font:textConf.font,size:textConf.size,bold:textConf.bold,italic:textConf.italic,color:textConf.color,x:coords[0]-5,y:coords[1]+(coords[3]/2),text:typeof prop.labelsAboveFormatter==='function'?prop.labelsAboveFormatter(this,this.left[i]):RGraph.numberFormat({object:this,number:this.left[i].toFixed(typeof prop.labelsAboveDecimals==='number'?prop.labelsAboveDecimals:0),unitspre:prop.labelsAboveUnitsPre,unitspost:prop.labelsAboveUnitsPost}),valign:'center',halign:'right',tag:'labels.above'});}else if(typeof this.left[i]==='object'){for(var j=0;j<this.left[i].length;++j,++seq){if(prop.grouping==='stacked'&&j!==(this.left[i].length-1)){continue;}
var coords=coordsLeft[seq];RGraph.text({object:this,font:textConf.font,size:textConf.size,bold:textConf.bold,italic:textConf.italic,color:textConf.color,x:coords[0]-5,y:coords[1]+(coords[3]/2),text:typeof prop.labelsAboveFormatter==='function'?prop.labelsAboveFormatter(this,this.left[i][j]):RGraph.numberFormat({object:this,number:RGraph.isNull(this.left[i][j])||isNaN(this.left[i][j])?'':(prop.grouping==='stacked'?RGraph.arraySum(this.left[i]):Number(this.left[i][j])).toFixed(typeof prop.labelsAboveDecimals==='number'?prop.labelsAboveDecimals:0),unitspre:prop.labelsAboveUnitsPre,unitspost:prop.labelsAboveUnitsPost}),valign:'center',halign:'right',tag:'labels.above'});}
seq--;}}
for(i=0,seq=0;i<coordsRight.length;++i,++seq){if(typeof this.right[i]==='number'){var coords=coordsRight[seq];RGraph.text({object:this,font:textConf.font,size:textConf.size,bold:textConf.bold,italic:textConf.italic,color:textConf.color,x:coords[0]+coords[2]+5+(prop.variant==='3d'?10:0),y:coords[1]+(coords[3]/2)+(prop.variant==='3d'?-5:0),text:typeof prop.labelsAboveFormatter==='function'?prop.labelsAboveFormatter(this,this.right[i]):RGraph.numberFormat({object:this,number:this.right[i].toFixed(typeof prop.labelsAboveDecimals==='number'?prop.labelsAboveDecimals:0),unitspre:prop.labelsAboveUnitsPre,unitspost:prop.labelsAboveUnitsPost}),valign:'center',halign:'left',tag:'labels.above'});}else if(typeof this.right[i]==='object'){for(var j=0;j<this.right[i].length;++j,++seq){if(prop.grouping==='stacked'&&j!==(this.right[i].length-1)){continue;}
var coords=coordsRight[seq];RGraph.text({object:this,font:textConf.font,size:textConf.size,bold:textConf.bold,italic:textConf.italic,color:textConf.color,x:coords[0]+coords[2]+5+(prop.variant==='3d'?10:0),y:coords[1]+(coords[3]/2)+(prop.variant==='3d'?-5:0),text:typeof prop.labelsAboveFormatter==='function'?prop.labelsAboveFormatter(this,this.right[i][j]):RGraph.numberFormat({object:this,number:RGraph.isNull(this.right[i][j])||isNaN(this.right[i][j])?'':prop.grouping==='stacked'?RGraph.arraySum(this.right[i]).toFixed(prop.labelsAboveDecimals):Number(this.right[i][j]).toFixed(typeof prop.labelsAboveDecimals==='number'?prop.labelsAboveDecimals:0),unitspre:prop.labelsAboveUnitsPre,unitspost:prop.labelsAboveUnitsPost}),valign:'center',halign:'left',tag:'labels.above'});}
--seq;}}};this.drawTitles=function()
{var textConf=RGraph.getTextConf({object:this,prefix:'titleLeft'});if(typeof prop.titleLeft==='string'){RGraph.text({object:this,font:textConf.font,size:textConf.size,bold:textConf.bold,italic:textConf.italic,color:textConf.color,x:this.marginLeft+5,y:this.marginTop-5,text:prop.titleLeft,halign:'left',valign:'bottom',tag:'title.left'});}
var textConf=RGraph.getTextConf({object:this,prefix:'titleRight'});if(typeof prop.titleRight==='string'){RGraph.text({object:this,font:textConf.font,size:textConf.size,bold:textConf.bold,italic:textConf.italic,color:textConf.color,x:this.canvas.width-this.marginRight-5,y:this.marginTop-5,text:prop.titleRight,halign:'right',valign:'bottom',tag:'title.right'});}
if(typeof prop.title==='string'){RGraph.drawTitle(this,prop.title,this.marginTop,null,typeof prop.titleSize==='number'?prop.titleSize:null);}};this.getShape=function(e)
{var canvas=this.canvas,context=this.context,mouseXY=RGraph.getMouseXY(e)
for(var i=0;i<this.coords.length;i++){var mouseX=mouseXY[0],mouseY=mouseXY[1],left=this.coords[i][0],top=this.coords[i][1],width=this.coords[i][2],height=this.coords[i][3]
this.path('b r % % % %',left,top,width,height);var over=this.context.isPointInPath(mouseX,mouseY);if(over){if(RGraph.parseTooltipText){var tooltip=RGraph.parseTooltipText(prop.tooltips,i);}
var indexes=RGraph.sequentialIndexToGrouped(i,this.data2),group=indexes[0],index=indexes[1],group2=group;if((group+1)>this.left.length){group2-=this.left.length;}
return{object:this,x:left,y:top,width:width,height:height,tooltip:typeof tooltip==='string'?tooltip:null,sequentialIndex:i,index:index,dataset:group,dataset2:group2,label:prop.yaxisLabels&&typeof prop.yaxisLabels[group2]==='string'?prop.yaxisLabels[group2]:null};}}
return null;};this.highlight=function(shape)
{if(typeof prop.highlightStyle==='function'){(prop.highlightStyle)(shape);}else if(typeof prop.highlightStyle==='string'&&prop.highlightStyle==='invert'){for(var i=0;i<this.coords.length;++i){if(i!==shape.sequentialIndex){this.path('b r % % % % s % f %',this.coords[i][0],this.coords[i][1],this.coords[i][2],this.coords[i][3],prop.highlightStroke,prop.highlightFill);}}}else{RGraph.Highlight.rect(this,shape);}};this.getValue=function(e)
{var obj=e.target.__object__;var mouseXY=RGraph.getMouseXY(e);var mouseX=mouseXY[0];if(mouseX>this.marginLeft&&mouseX<((this.canvas.width/2)-(prop.marginCenter/2))){var value=(mouseX-prop.marginLeft)/this.axisWidth;value=this.max-(value*this.max);}
if(mouseX<(this.canvas.width-this.marginRight)&&mouseX>((this.canvas.width/2)+(prop.marginCenter/2))){var value=(mouseX-prop.marginLeft-this.axisWidth-prop.marginCenter)/this.axisWidth;value=(value*this.max);}
return value;};this.getObjectByXY=function(e)
{var mouseXY=RGraph.getMouseXY(e);if(mouseXY[0]>prop.marginLeft&&mouseXY[0]<(this.canvas.width-prop.marginRight)&&mouseXY[1]>prop.marginTop&&mouseXY[1]<(this.canvas.height-prop.marginBottom)){return this;}};this.getXCoord=function(value)
{if(value>this.max||value<0){return null;}
var ret=[];var offset=((value/this.max)*this.axisWidth);ret[0]=(this.marginLeft+this.axisWidth)-offset;ret[1]=(this.canvas.width-this.marginRight-this.axisWidth)+offset;return ret;};this.parseColors=function()
{var prop=this.properties;if(this.original_colors.length===0){this.original_colors.colors=RGraph.arrayClone(prop.colors);this.original_colors.highlightStroke=RGraph.arrayClone(prop.highlightStroke);this.original_colors.highlightFill=RGraph.arrayClone(prop.highlightFill);this.original_colors.axesColor=RGraph.arrayClone(prop.axesColor);this.original_colors.colorsStroke=RGraph.arrayClone(prop.colorsStroke);}
var prop=this.properties;var colors=prop.colors;for(var i=0;i<colors.length;++i){colors[i]=this.parseSingleColorForGradient(colors[i]);}
prop.highlightStroke=this.parseSingleColorForGradient(prop.highlightStroke);prop.highlightFill=this.parseSingleColorForGradient(prop.highlightFill);prop.axesColor=this.parseSingleColorForGradient(prop.axesColor);prop.colorsStroke=this.parseSingleColorForGradient(prop.colorsStroke);};this.reset=function()
{};this.parseSingleColorForGradient=function(color)
{if(!color||typeof color!='string'){return color;}
if(color.match(/^gradient\((.*)\)$/i)){if(color.match(/^gradient\(({.*})\)$/i)){return RGraph.parseJSONGradient({object:this,def:RegExp.$1});}
var parts=RegExp.$1.split(':');var grad=this.context.createLinearGradient(prop.marginLeft,0,this.canvas.width-prop.marginRight,0);var diff=1/(parts.length-1);grad.addColorStop(0,RGraph.trim(parts[0]));for(var j=1;j<parts.length;++j){grad.addColorStop(j*diff,RGraph.trim(parts[j]));}}
return grad?grad:color;};this.on=function(type,func)
{if(type.substr(0,2)!=='on'){type='on'+type;}
if(typeof this[type]!=='function'){this[type]=func;}else{RGraph.addCustomEventListener(this,type,func);}
return this;};this.drawBackgroundGrid=function()
{if(prop.backgroundGrid){var variant=prop.variant,color=prop.backgroundGridColor,numvlines=prop.xaxisLabelsCount,numhlines=this.left.length,vlines=prop.backgroundGridVlines,hlines=prop.backgroundGridHlines,linewidth=prop.backgroundGridLinewidth;if(typeof prop.backgroundGridHlinesCount==='number'){numhlines=prop.backgroundGridHlinesCount;}
if(typeof prop.backgroundGridVlinesCount==='number'){numvlines=prop.backgroundGridVlinesCount;}
this.context.lineWidth=linewidth;if(variant=='3d'){this.context.save();this.context.translate(prop.variantThreedOffsetx,-1*prop.variantThreedOffsety);}
if(vlines){for(var i=0;i<=numvlines;i+=1){this.path('b m % % l % % s %',this.marginLeft+(this.axisWidth/numvlines)*i,this.marginTop,this.marginLeft+(this.axisWidth/numvlines)*i,this.marginTop+this.axisHeight,color);}}
if(hlines){for(var i=0;i<=numhlines;i+=1){this.path('b m % % l % % s %',this.marginLeft,this.marginTop+(this.axisHeight/numhlines)*i,this.marginLeft+this.axisWidth,this.marginTop+(this.axisHeight/numhlines)*i,color);}}
if(vlines){for(var i=0;i<=numvlines;i+=1){this.path('b m % % l % % s %',this.marginLeft+this.marginCenter+this.axisWidth+(this.axisWidth/numvlines)*i,this.marginTop,this.marginLeft+this.marginCenter+this.axisWidth+(this.axisWidth/numvlines)*i,this.marginTop+this.axisHeight,color);}}
if(hlines){for(var i=0;i<=numhlines;i+=1){this.path('b m % % l % % s %',this.marginLeft+this.axisWidth+this.marginCenter,this.marginTop+(this.axisHeight/numhlines)*i,this.marginLeft+this.axisWidth+this.marginCenter+this.axisWidth,this.marginTop+(this.axisHeight/numhlines)*i,color);}}
if(variant=='3d'){this.context.restore();}}};this.firstDrawFunc=function()
{};this.getMarginCenter=function()
{var bold=typeof prop.yaxisLabelsBold==='boolean'?prop.yaxisLabelsBold:prop.textBold,font=typeof prop.yaxisLabelsFont==='string'?prop.yaxisLabelsFont:prop.textFont,size=typeof prop.yaxisLabelsSize==='number'?prop.yaxisLabelsSize:prop.textSize;for(var i=0,len=0;i<prop.yaxisLabels.length;++i){len=Math.max(len,RGraph.measureText(prop.yaxisLabels[i],bold,font,size)[0]);}
return len+15;};this.grow=function()
{var opt=arguments[0]||{},frames=opt.frames||30,frame=0,callback=arguments[1]||function(){},obj=this;var originalLeft=RGraph.arrayClone(this.left),originalRight=RGraph.arrayClone(this.right);if(RGraph.isNull(prop.xaxisScaleMax)){var xmax=0;this.getMax();this.set('xaxisScaleMax',this.scale2.max);}
var iterator=function()
{var easingMultiplier=RGraph.Effects.getEasingMultiplier(frames,frame);for(var i=0;i<obj.left.length;i+=1){if(typeof obj.left[i]==='number'){obj.left[i]=easingMultiplier*originalLeft[i];}else{for(var j=0;j<obj.left[i].length;++j){obj.left[i][j]=easingMultiplier*originalLeft[i][j];}}}
for(var i=0;i<obj.right.length;i+=1){if(typeof obj.right[i]==='number'){obj.right[i]=easingMultiplier*originalRight[i];}else{for(var j=0;j<obj.right[i].length;++j){obj.right[i][j]=easingMultiplier*originalRight[i][j];}}}
RGraph.redrawCanvas(obj.canvas);if(frame<frames){frame+=1;RGraph.Effects.updateCanvas(iterator);}else{callback(obj);}};iterator();return this;};this.wave=function()
{var obj=this,opt=arguments[0]||{};opt.frames=opt.frames||120;opt.startFrames_left=[];opt.startFrames_right=[];opt.counters_left=[];opt.counters_right=[];var framesperbar=opt.frames/3,frame_left=-1,frame_right=-1,callback=arguments[1]||function(){},original_left=RGraph.arrayClone(obj.left),original_right=RGraph.arrayClone(obj.right);for(var i=0,len=obj.left.length;i<len;i+=1){opt.startFrames_left[i]=((opt.frames/3)/(obj.left.length-1))*i;opt.startFrames_right[i]=((opt.frames/3)/(obj.right.length-1))*i;opt.counters_left[i]=0;opt.counters_right[i]=0;}
obj.draw();obj.set('xaxisScaleMax',obj.scale2.max);RGraph.clear(obj.canvas);for(var i=0,len=obj.left.length;i<len;i+=1){if(typeof obj.left[i]==='number')obj.left[i]=0;if(typeof obj.right[i]==='number')obj.right[i]=0;}
function iteratorLeft()
{++frame_left;for(var i=0,len=obj.left.length;i<len;i+=1){if(frame_left>opt.startFrames_left[i]){var isNull=RGraph.isNull(obj.left[i]);if(typeof obj.left[i]==='number'){obj.left[i]=Math.min(Math.abs(original_left[i]),Math.abs(original_left[i]*((opt.counters_left[i]++)/framesperbar)));if(original_left[i]<0){obj.left[i]*=-1;}}else if(RGraph.isArray(obj.left[i])){for(var j=0;j<obj.left[i].length;++j){obj.left[i][j]=Math.min(Math.abs(original_left[i][j]),Math.abs(original_left[i][j]*((opt.counters_left[i]++)/framesperbar)));if(original_left[i][j]<0){obj.left[i][j]*=-1;}}}
if(isNull){obj.left[i]=null;}}else{obj.left[i]=typeof obj.left[i]==='object'&&obj.left[i]?RGraph.arrayPad([],obj.left[i].length,0):(RGraph.isNull(obj.left[i])?null:0);}}
if(frame_left<opt.frames){RGraph.redrawCanvas(obj.canvas);RGraph.Effects.updateCanvas(iteratorLeft);}}
function iteratorRight()
{++frame_right;for(var i=0,len=obj.right.length;i<len;i+=1){if(frame_right>opt.startFrames_right[i]){var isNull=RGraph.isNull(obj.right[i]);if(typeof obj.left[i]==='number'){obj.right[i]=Math.min(Math.abs(original_right[i]),Math.abs(original_right[i]*((opt.counters_right[i]++)/framesperbar)));if(original_right[i]<0){obj.right[i]*=-1;}
if(isNull){obj.right[i]=null;}}else if(RGraph.isArray(obj.right[i])){for(var j=0;j<obj.right[i].length;++j){obj.right[i][j]=Math.min(Math.abs(original_right[i][j]),Math.abs(original_right[i][j]*((opt.counters_right[i]++)/framesperbar)));if(original_right[i][j]<0){obj.right[i][j]*=-1;}}}}else{obj.right[i]=typeof obj.right[i]==='object'&&obj.right[i]?RGraph.arrayPad([],obj.right[i].length,0):(RGraph.isNull(obj.right[i])?null:0);}}
if(frame_right<opt.frames){RGraph.redrawCanvas(obj.canvas);RGraph.Effects.updateCanvas(iteratorRight);}else{callback(this);}}
iteratorLeft();iteratorRight();return this;};this.tooltipSubstitutions=function(opt)
{var indexes=RGraph.sequentialIndexToGrouped(opt.index,this.data2);if(indexes[0]>=this.left.length){var dataset2=indexes[0]-this.left.length,side='right',values=this.right[dataset2];}else{var dataset2=indexes[0],side='left'
values=this.left[dataset2];}
if(typeof values==='number'){values=[values];}
return{index:indexes[1],dataset:indexes[0],dataset2:dataset2,sequentialIndex:opt.index,value:typeof this.data2[opt.index]==='number'?this.data2[opt.index]:this.data2[indexes[0]][indexes[1]],values:values,side:side};};this.tooltipsFormattedCustom=function(specific,index)
{var label;var side=((specific.dataset+1)>this.left.length)?'right':'left';if(typeof this[side][specific.dataset2]==='object'){label=(!RGraph.isNull(prop.tooltipsFormattedKeyLabels)&&typeof prop.tooltipsFormattedKeyLabels==='object'&&prop.tooltipsFormattedKeyLabels[index])?prop.tooltipsFormattedKeyLabels[index]:'';}else{label=(!RGraph.isNull(prop.tooltipsFormattedKeyLabels)&&typeof prop.tooltipsFormattedKeyLabels==='object'&&prop.tooltipsFormattedKeyLabels[specific.dataset2])?prop.tooltipsFormattedKeyLabels[specific.dataset2]:'';}
return{label:label};};RGraph.register(this);RGraph.parseObjectStyleConfig(this,conf.options);};